### Function Macro

# Atk DEFINE_TYPE

since: 1.22

#### Declaration [src]

    #define ATK_DEFINE_TYPE (
      TN,
      t_n,
      T_P
    )

#### Description [src]

A convenience macro for type ATK implementations, which declares a class initialization function, an instance initialization function (see `GTypeInfo` for information about these) and a static variable named `t_n` _parent_class pointing to the parent class. Furthermore, it defines a _get_type() function.

Available since: 1.22

This function is not directly available to language bindings.

#### Parameters

`TN`

  Type: `-`

  The name of the new type, in Camel case.

`t_n`

  Type: `-`

  The name of the new type, in lowercase, with words separated by ‘_’.

`T_P`

  Type: `-`

  The `GType` of the parent type.